com.jnape.palatable.lambda.optics.functions

## Class Over<S,T,A,B>

- java.lang.Object
- - com.jnape.palatable.lambda.optics.functions.Over<S,T,A,B>

- Type Parameters:
    `S` - the type of the larger value
    `T` - the type of the larger updated value
    `A` - the type of the smaller retrieving value
    `B` - the type of the smaller setting value
  All Implemented Interfaces:
    Fn1<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>>, Fn2<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<? super A,? extends B>,Fn1<S,T>>, Fn3<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<? super A,? extends B>,S,T>, Applicative<Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,?>>, Cartesian<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<?,?>>, Cocartesian<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<?,?>>, Contravariant<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Profunctor<?,Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<?,?>>>, Functor<Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,?>>, Profunctor<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<?,?>>, Monad<Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,?>>, MonadReader<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,?>>, MonadRec<Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,?>>, MonadWriter<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<Fn1<? super A,? extends B>,Fn1<S,T>>,Fn1<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,?>>

      public final class Over<S,T,A,B>
      extends Object
      implements Fn3<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<? super A,? extends B>,S,T>

  Given an `Optic`, a function from `A` to `B`, and a "larger" value `S`, produce a `T` by retrieving the `A` from the `S`, applying the function, and updating the `S` with the `B` resulting from the function.

  This function is similar to `Set`, except that it allows the setting value `B` to be derived from `S` via function application, rather than provided.

  See Also:
    `Set`, `View`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `checkedApply(Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B> optic, Fn1<? super A,? extends B> fn, S s)`
    `static <S,T,A,B> Over<S,T,A,B>` | `over()`
    `static <S,T,A,B> Fn2<Fn1<? super A,? extends B>,S,T>` | `over(Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B> optic)`
    `static <S,T,A,B> Fn1<S,T>` | `over(Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B> optic, Fn1<? super A,? extends B> fn)`
    `static <S,T,A,B> T` | `over(Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B> optic, Fn1<? super A,? extends B> fn, S s)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `checkedApply, curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public T checkedApply(Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B> optic,
                                Fn1<? super A,? extends B> fn,
                                S s)

      Specified by:
        `checkedApply` in interface `Fn3<Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B>,Fn1<? super A,? extends B>,S,T>`

    - #### over

          public static <S,T,A,B> Over<S,T,A,B> over()

    - #### over

          public static <S,T,A,B> Fn2<Fn1<? super A,? extends B>,S,T> over(Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B> optic)

    - #### over

          public static <S,T,A,B> Fn1<S,T> over(Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B> optic,
                                                Fn1<? super A,? extends B> fn)

    - #### over

          public static <S,T,A,B> T over(Optic<? super Fn1<?,?>,? super Identity<?>,S,T,A,B> optic,
                                         Fn1<? super A,? extends B> fn,
                                         S s)